diff --git a/fw/t/fuzzer.c b/fw/t/fuzzer.c
index 34efccc97..17cb89437 100644
--- a/fw/t/fuzzer.c
+++ b/fw/t/fuzzer.c
@@ -50,8 +50,13 @@ typedef struct {
 static FuzzMsg spaces[] = {
 	{""}
 };
+#define FUZZ_FLD_F_METHOD_GET		(0x0001 << FUZZ_MSG_F_SHIFT)
+#define FUZZ_FLD_F_METHOD_HEAD		(0x0002 << FUZZ_MSG_F_SHIFT)
+#define FUZZ_FLD_F_METHOD_POST		(0x0004 << FUZZ_MSG_F_SHIFT)
 static FuzzMsg methods[] = {
-	{"GET"}, {"HEAD"}, {"POST"}
+	{"GET", FUZZ_FLD_F_METHOD_GET},
+	{"HEAD", FUZZ_FLD_F_METHOD_HEAD},
+	{"POST", FUZZ_FLD_F_METHOD_POST}
 };
 static FuzzMsg uri_path_start[] = {
 	{"http:/"}, {""}
@@ -132,7 +137,12 @@ static FuzzMsg expires[] = {
 	{"Tue, 31 Jan 2012 15:02:53 GMT"},
 	{"Tue, 999 Jan 2012 15:02:53 GMT", FUZZ_MSG_F_INVAL}
 };
-
+static FuzzMsg schemes[] = {
+	{"https"}, {"http", FUZZ_MSG_F_INVAL}
+};
+static FuzzMsg paths[] = {
+	{"/"}, {"/index.html"}
+};
 /*
  * A function that makes sure that the header field value is compatible
  * with the RFC. That is needed in complex cases where the correctness
@@ -205,35 +215,38 @@ fld_expires(TfwFuzzContext *ctx, int type, int fld, int val)
  * @func	- the function to check the correctness of the values;
  */
 static struct {
-	char		*key;
+	char		*h1_key;
+	char		*h2_key;
 	FuzzMsg		*vals;
 	fld_func_t	func;
 } fld_data[N_FIELDS] = {
 	[0 ... N_FIELDS-1] = { 0 },
-	[SPACES]		= { NULL, spaces },
-	[METHOD]		= { NULL, methods },
-	[HTTP_VER]		= { NULL, versions },
-	[RESP_CODE]		= { NULL, resp_code },
-	[URI_PATH_START]	= { NULL, uri_path_start },
-	[URI_FILE]		= { NULL, uri_file },
-	[CONNECTION]		= { "Connection:", conn_val },
-	[USER_AGENT]		= { "User-Agent:", ua_val },
-	[HOST]			= { "Host:", host_val },
-	[X_FORWARDED_FOR]	= { "X-Forwarded-For:", host_val },
-	[CONTENT_TYPE]		= { "Content-Type:", content_type },
-	[CONTENT_LENGTH]	= { "Content-Length:", content_len },
-	[TRANSFER_ENCODING]	= { "Transfer-Encoding:", transfer_encoding,
+	[SPACES]		= { NULL, NULL, spaces },
+	[METHOD]		= { NULL, ":method", methods },
+	[HTTP_VER]		= { NULL, NULL, versions },
+	[RESP_CODE]		= { NULL, NULL, resp_code },
+	[URI_PATH_START]	= { NULL, NULL, uri_path_start },
+	[URI_FILE]		= { NULL, NULL, uri_file },
+	[CONNECTION]		= { "Connection:", NULL, conn_val },
+	[USER_AGENT]		= { "User-Agent:", "user-agent", ua_val },
+	[HOST]			= { "Host:", ":authority", host_val },
+	[X_FORWARDED_FOR]	= { "X-Forwarded-For:", "x-forwarded-for", host_val },
+	[CONTENT_TYPE]		= { "Content-Type:", "content-type", content_type },
+	[CONTENT_LENGTH]	= { "Content-Length:", "content-length", content_len },
+	[TRANSFER_ENCODING]	= { "Transfer-Encoding:", NULL, transfer_encoding,
 				    fld_transfer_encoding },
-	[ACCEPT]		= { "Accept:", accept },
-	[ACCEPT_LANGUAGE]	= { "Accept-Language:", accept_language },
-	[ACCEPT_ENCODING]	= { "Accept-Encoding:", accept_encoding },
-	[ACCEPT_RANGES]		= { "Accept-Ranges:", accept_ranges },
-	[COOKIE]		= { "Cookie:", cookie },
-	[SET_COOKIE]		= { "Set-Cookie:", set_cookie },
-	[ETAG]			= { "ETag:", etag },
-	[SERVER]		= { "Server:", server },
-	[CACHE_CONTROL]		= { "Cache-Control:", cache_control },
-	[EXPIRES]		= { "Expires:", expires, fld_expires },
+	[ACCEPT]		= { "Accept:", "accept", accept },
+	[ACCEPT_LANGUAGE]	= { "Accept-Language:", "accept-language", accept_language },
+	[ACCEPT_ENCODING]	= { "Accept-Encoding:", "accept-encoding", accept_encoding },
+	[ACCEPT_RANGES]		= { "Accept-Ranges:", "accept-ranges", accept_ranges },
+	[COOKIE]		= { "Cookie:", "cookie", cookie },
+	[SET_COOKIE]		= { "Set-Cookie:", "set-cookie", set_cookie },
+	[ETAG]			= { "ETag:", "etag", etag },
+	[SERVER]		= { "Server:", "server", server },
+	[CACHE_CONTROL]		= { "Cache-Control:", "cache-control", cache_control },
+	[EXPIRES]		= { "Expires:", "expires", expires, fld_expires },
+	[SCHEME]		= { NULL, ":scheme", schemes },
+	[PATH]			= { NULL, ":path", paths },
 };
 
 #define A_URI "ABCDEFGHIJKLMNOPQRSTUVWXYZ" \
@@ -273,6 +286,7 @@ static struct {
 	int singular;
 	int dissipation;
 	int max_val_len;
+	char *random_nums;
 } gen_vector[N_FIELDS] = {
 	/* SPACES */
 	{sizeof(spaces) / sizeof(FuzzMsg), 0, NULL, NULL},
@@ -295,12 +309,14 @@ static struct {
 	/* X_FORWARDED_FOR */
 	{sizeof(host_val) / sizeof(FuzzMsg), 2, A_X_FF, A_X_FF_INVAL, 0, 1},
 	/* CONTENT_TYPE */
-	{sizeof(content_type) / sizeof(FuzzMsg), 0, NULL, NULL, 1, 1},
+	{sizeof(content_type) / sizeof(FuzzMsg), 0, NULL, NULL,
+		1, 1, 0, "8929874"},
 	/* CONTENT_LENGTH */
-	{sizeof(content_len) / sizeof(FuzzMsg), 2, "0123456789", A_URI, 1, 1,
-		MAX_CONTENT_LENGTH_LEN},
+	{sizeof(content_len) / sizeof(FuzzMsg), 2, "0123456789", A_URI,
+		1, 1, MAX_CONTENT_LENGTH_LEN, "154634"},
 	/* TRANSFER_ENCODING */
-	{sizeof(transfer_encoding) / sizeof(FuzzMsg), 0, NULL, NULL, 0, 0},
+	{sizeof(transfer_encoding) / sizeof(FuzzMsg), 0, NULL, NULL,
+		0, 0, 0, "1234"},
 	/* ACCEPT */
 	{sizeof(accept) / sizeof(FuzzMsg), 0, NULL, NULL, 0, 1},
 	/* ACCEPT_LANGUAGE */
@@ -321,6 +337,10 @@ static struct {
 	{sizeof(cache_control) / sizeof(FuzzMsg), 0, NULL, NULL, 0, 1},
 	/* EXPIRES */
 	{sizeof(expires) / sizeof(FuzzMsg), 0, NULL, NULL, 0, 1},
+	/* SCHEME */
+	{sizeof(schemes) / sizeof(FuzzMsg), 0, NULL, NULL},
+	/* PATH */
+	{sizeof(paths) / sizeof(FuzzMsg), 0, NULL, NULL},
 	/* TRANSFER_ENCODING_NUM */
 	{2, 0, NULL, NULL},
 	/* URI_PATH_DEPTH */
@@ -353,36 +373,61 @@ gen_vector_move(TfwFuzzContext *ctx, int i)
 }
 
 static void
-addch(char **p, char *end, char ch)
+addch(TfwFuzzContext *ctx, char **p, char *end, char ch)
 {
-	if (!ch)
-		return;
+	BUG_ON(!ch);
 
-	if(*p + 1 > end)
-		return;
+	if(*p == end) {
+		ctx->is_buf_not_enough = true;
+	}
+	else
+	{
+		*(*p)++ = ch;
+	}
+}
 
-	*(*p)++ = ch;
+static void
+add_string_n(TfwFuzzContext *ctx, char **p, char *end, const char *str, int n)
+{
+	while (*p != end && n) {
+		*(*p)++ = *str++;
+		--n;
+	}
+
+	if (n) {
+		ctx->is_buf_not_enough = true;
+	}
 }
 
 static void
-add_string(char **p, char *end, const char *str)
+add_string(TfwFuzzContext *ctx, char **p, char *end, const char *str)
 {
-	for (; *str != '\0'; str++)
-		addch(p, end, *str);
+	while (*p != end && *str != '\0') {
+		*(*p)++ = *str++;
+	}
+
+	if (*str != '\0') {
+		ctx->is_buf_not_enough = true;
+	}
 }
 
 static void
-add_rand_string(char **p, char *end, int n, const char *seed)
+add_rand_string(TfwFuzzContext *ctx, char **p, char *end, int n, const char *seed)
 {
-	int i, len;
+	int len;
 	unsigned int idxval;
 
 	BUG_ON(!seed);
 
 	len = strlen(seed);
-	for (i = 0; i < n; ++i) {
-		idxval = (i + 333) ^ seed[i % len];
-		addch(p, end, seed[idxval % len]);
+	while (*p != end && n) {
+		--n;
+		idxval = (n + 333) ^ seed[n % len];
+		*(*p)++ = seed[idxval % len];
+	}
+
+	if (n) {
+		ctx->is_buf_not_enough = true;
 	}
 }
 
@@ -398,7 +443,7 @@ __add_field(TfwFuzzContext *ctx, int type, char **p, char *end, int t, int n)
 		unsigned int r;
 		FuzzMsg fmsg = fld_data[t].vals[n];
 
-		add_string(p, end, fmsg.sval);
+		add_string(ctx, p, end, fmsg.sval);
 
 		if (fld_data[t].func)
 			r = fld_data[t].func(ctx, type, t, n);
@@ -422,10 +467,10 @@ __add_field(TfwFuzzContext *ctx, int type, char **p, char *end, int t, int n)
 		if (n % INVALID_FIELD_PERIOD || ctx->is_only_valid) {
 			if (gen_vector[t].max_val_len)
 				len = gen_vector[t].max_val_len;
-			add_rand_string(p, end, len, gen_vector[t].a_val);
+			add_rand_string(ctx, p, end, len, gen_vector[t].a_val);
 			r = FUZZ_VALID;
 		} else {
-			add_rand_string(p, end, len, gen_vector[t].a_inval);
+			add_rand_string(ctx, p, end, len, gen_vector[t].a_inval);
 			r = FUZZ_INVALID;
 		}
 
@@ -450,27 +495,84 @@ add_field(TfwFuzzContext *ctx, int type, char **p, char *end, int t)
 	return __add_field(ctx, type, p, end, t, ctx->i[t]);
 }
 
+static void
+__h2_write_int(unsigned long index, char **p, char *end)
+{
+	static const unsigned short max = 0x7F;
+	static const unsigned short mask = 0x0;
+
+	if (likely(index < max)) {
+		index |= mask;
+	}
+	else {
+		*(*p)++ = max | mask;
+		index -= max;
+		while (index > max) {
+			if(*p + 1 > end)
+				return;
+			*(*p)++ = (index & 0x7F) | 0x80;
+			index >>= 7;
+		}
+	}
+
+	if(*p + 1 > end)
+		return;
+
+	*(*p)++ = index;
+}
+
 static unsigned int
 __add_header(TfwFuzzContext *ctx, int type, char **p, char *end, int t, int n)
 {
+	static char *saved_p = NULL, *saved_end = NULL;
+	static char h2_buf[10*1024*1024] = {};
+	static size_t remain_p = 0;
 	unsigned int v = 0, i;
 
 	BUG_ON(t < 0);
 	BUG_ON(t >= TRANSFER_ENCODING_NUM);
 
-	BUG_ON(!fld_data[t].key);
+	BUG_ON(!fld_data[t].h1_key && !fld_data[t].h2_key);
+
+	if (type == FUZZ_REQ_H2) {
+		saved_p = *p;
+		saved_end = end;
+		remain_p = saved_end - saved_p;
+		BUG_ON(remain_p > sizeof(h2_buf));
+		*p = h2_buf;
+		end = h2_buf + remain_p;
+	}
+	else
+	{
+		add_string(ctx, p, end, fld_data[t].h1_key);
+		v |= add_field(ctx, type, p, end, SPACES);
+	}
 
-	add_string(p, end, fld_data[t].key);
-	v |= add_field(ctx, type, p, end, SPACES);
 	v |= add_field(ctx, type, p, end, t);
 	for (i = 0; i < n; ++i) {
-		addch(p, end, ',');
+		addch(ctx, p, end, ',');
 		v |= add_field(ctx, type, p, end, SPACES);
 		v |= __add_field(ctx, type, p, end, t, (i * 256) %
 			(gen_vector[t].size + gen_vector[t].over));
 	}
 
-	add_string(p, end, "\r\n");
+	if (type != FUZZ_REQ_H2) {
+		add_string(ctx, p, end, "\r\n");
+	}
+
+	if (type == FUZZ_REQ_H2) {
+		static const int LIT_HDR_FLD_WO_IND  = 0x00;
+		int h2_value_sz =  *p - h2_buf;
+		*p = saved_p;
+		if (*p < saved_end) {
+			*(*p)++ = LIT_HDR_FLD_WO_IND;
+		}
+
+		__h2_write_int(strlen(fld_data[t].h2_key), p, saved_end);
+		add_string(ctx, p, saved_end, fld_data[t].h2_key);
+		__h2_write_int(h2_value_sz, p, saved_end);
+		add_string_n(ctx, p, saved_end, h2_buf, h2_value_sz);
+	}
 
 	if (v & FUZZ_INVALID)
 		T_DBG("generate invalid header %d\n", t);
@@ -484,10 +586,27 @@ static unsigned int
 __add_header_rand(TfwFuzzContext *ctx, int type,
 		  char **p, char *end, int t, int n)
 {
-	static unsigned int rand = 0;
+	unsigned int rand;
+
+	char *fld_random_nums = gen_vector[t].random_nums;
+
+	BUG_ON(!fld_random_nums);
+	rand = fld_random_nums[ctx->i[t] % strlen(fld_random_nums)];
 
 	/* For now, just alternate between adding a header and not adding. */
-	return (++rand) % 2 ? __add_header(ctx, type, p, end, t, n) : FUZZ_VALID;
+	if (++rand % 2) {
+		return __add_header(ctx, type, p, end, t, n);
+	}
+
+	switch (t) {
+	case CONTENT_LENGTH:
+		return FUZZ_VALID | FUZZ_MSG_F_EMPTY_BODY;
+	    break;
+	default:
+	    break;
+	}
+
+	return FUZZ_VALID;
 }
 
 static unsigned int
@@ -496,6 +615,12 @@ add_header(TfwFuzzContext *ctx, int type, char **p, char *end, int t)
 	return __add_header(ctx, type, p, end, t, 0);
 }
 
+static unsigned int
+add_header_rand(TfwFuzzContext *ctx, int type, char **p, char *end, int t)
+{
+	return __add_header_rand(ctx, type, p, end, t, 0);
+}
+
 static unsigned int
 add_body(TfwFuzzContext *ctx, char **p, char *end, int type)
 {
@@ -525,12 +650,13 @@ add_body(TfwFuzzContext *ctx, char **p, char *end, int type)
 			T_DBG("1/2 invalid body %lu\n", len);
 		}
 
-		add_rand_string(p, end, len, A_BODY);
+		add_rand_string(ctx, p, end, len, A_BODY);
 	}
 	else {
 		int chunks = ctx->i[BODY_CHUNKS_NUM] + 1;
 		size_t chlen, rem, step;
 
+		BUG_ON(type == FUZZ_REQ_H2);
 		BUG_ON(chunks <= 0);
 
 		if (len > 0) {
@@ -547,8 +673,8 @@ add_body(TfwFuzzContext *ctx, char **p, char *end, int type)
 
 				snprintf(buf, sizeof(buf), "%zx", step);
 
-				add_string(p, end, buf);
-				add_string(p, end, "\r\n");
+				add_string(ctx, p, end, buf);
+				add_string(ctx, p, end, "\r\n");
 
 				if (!ctx->is_only_valid && step
 				    && !(i % INVALID_BODY_PERIOD))
@@ -559,12 +685,12 @@ add_body(TfwFuzzContext *ctx, char **p, char *end, int type)
 					      " chunks %d\n", len, chunks);
 				}
 
-				add_rand_string(p, end, step, A_BODY);
-				add_string(p, end, "\r\n");
+				add_rand_string(ctx, p, end, step, A_BODY);
+				add_string(ctx, p, end, "\r\n");
 			}
 		}
 
-		add_string(p, end, "0\r\n\r\n");
+		add_string(ctx, p, end, "0\r\n\r\n");
 	}
 
 	return ret;
@@ -616,6 +742,20 @@ add_duplicates(TfwFuzzContext *ctx, int type, char **p, char *end, int t)
 static bool
 fuzz_hdrs_compatible(TfwFuzzContext *ctx, int type, unsigned int v)
 {
+	/*
+	 * According to RFC 7231 4.3.* a payload within GET, HEAD,
+	 * DELETE, TRACE and CONNECT requests has no defined semantics
+	 * and implementations can reject it. We do this respecting overrides.
+	 */
+	if (type == FUZZ_REQ || type == FUZZ_REQ_H2) {
+		if (ctx->hdr_flags & (1 << CONTENT_LENGTH | 1 << CONTENT_TYPE)) {
+			unsigned int bodyless_methods = FUZZ_FLD_F_METHOD_GET
+							| FUZZ_FLD_F_METHOD_HEAD;
+			if (ctx->fld_flags[METHOD] & bodyless_methods) {
+				return false;
+			}
+		}
+	}
 	/*
 	 * RFC 7230 3.3.3: Any response with a 1xx (Informational),
 	 * 204 (No Content), or 304 (Not Modified) status code is
@@ -627,7 +767,7 @@ fuzz_hdrs_compatible(TfwFuzzContext *ctx, int type, unsigned int v)
 	 * in any response with a status code of 1xx (Informational) or
 	 * 204 (No Content).
 	 */
-	if (type & FUZZ_RESP) {
+	if (type == FUZZ_RESP) {
 		if ((ctx->fld_flags[RESP_CODE]
 		     & (FUZZ_FLD_F_STATUS_100
 			| FUZZ_FLD_F_STATUS_204
@@ -673,6 +813,7 @@ fuzz_init(TfwFuzzContext *ctx, bool is_only_valid)
 	memset(ctx->i, 0, sizeof(ctx->i));
 	ctx->is_only_valid = is_only_valid;
 	ctx->curr_duplicates = 0;
+	ctx->is_buf_not_enough = false;
 }
 EXPORT_SYMBOL(fuzz_init);
 
@@ -690,6 +831,10 @@ fuzz_gen(TfwFuzzContext *ctx, char *str, char *end, field_t start,
 {
 	int i, n, ret = FUZZ_VALID;
 	unsigned int v = 0;
+	char *end_minus_1 = end - 1;	// reserve one byte for NULL-character
+
+	BUG_ON(str > end);
+	BUG_ON(type != FUZZ_REQ && type != FUZZ_RESP);
 
 	ctx->hdr_flags = 0;
 	memset(ctx->fld_flags, 0, sizeof(ctx->fld_flags));
@@ -698,86 +843,175 @@ fuzz_gen(TfwFuzzContext *ctx, char *str, char *end, field_t start,
 		return -EINVAL;
 
 	if (type == FUZZ_REQ) {
-		v |= add_field(ctx, type, &str, end, METHOD);
-		addch(&str, end, ' ');
+		v |= add_field(ctx, type, &str, end_minus_1, METHOD);
+		addch(ctx, &str, end_minus_1, ' ');
 
-		v |= add_field(ctx, type, &str, end, URI_PATH_START);
-		addch(&str, end, '/');
-		v |= add_field(ctx, type, &str, end, HOST);
+		v |= add_field(ctx, type, &str, end_minus_1, URI_PATH_START);
+		addch(ctx, &str, end_minus_1, '/');
+		v |= add_field(ctx, type, &str, end_minus_1, HOST);
 		for (i = 0; i < ctx->i[URI_PATH_DEPTH] + 1; ++i) {
-			addch(&str, end, '/');
-			v |= add_field(ctx, type, &str, end, URI_FILE);
+			addch(ctx, &str, end_minus_1, '/');
+			v |= add_field(ctx, type, &str, end_minus_1, URI_FILE);
 		}
-		addch(&str, end, ' ');
+		addch(ctx, &str, end_minus_1, ' ');
 	}
 
-	add_string(&str, end, "HTTP/");
-	v |= add_field(ctx, type, &str, end, HTTP_VER);
+	add_string(ctx, &str, end_minus_1, "HTTP/");
+	v |= add_field(ctx, type, &str, end_minus_1, HTTP_VER);
 
 	if (type == FUZZ_RESP) {
-		addch(&str, end, ' ');
-		v |= add_field(ctx, type, &str, end, SPACES);
-		v |= add_field(ctx, type, &str, end, RESP_CODE);
+		addch(ctx, &str, end_minus_1, ' ');
+		v |= add_field(ctx, type, &str, end_minus_1, SPACES);
+		v |= add_field(ctx, type, &str, end_minus_1, RESP_CODE);
 	}
 
-	add_string(&str, end, "\r\n");
+	add_string(ctx, &str, end_minus_1, "\r\n");
 
 	if (type == FUZZ_REQ) {
-		v |= add_header(ctx, type, &str, end, HOST);
-		v |= add_duplicates(ctx, type, &str, end, HOST);
+		v |= add_header(ctx, type, &str, end_minus_1, HOST);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, HOST);
 
-		v |= add_header(ctx, type, &str, end, ACCEPT);
-		v |= add_duplicates(ctx, type, &str, end, ACCEPT);
+		v |= add_header(ctx, type, &str, end_minus_1, ACCEPT);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, ACCEPT);
 
-		v |= add_header(ctx, type, &str, end, ACCEPT_LANGUAGE);
-		v |= add_duplicates(ctx, type, &str, end, ACCEPT_LANGUAGE);
+		v |= add_header(ctx, type, &str, end_minus_1, ACCEPT_LANGUAGE);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, ACCEPT_LANGUAGE);
 
-		v |= add_header(ctx, type, &str, end, ACCEPT_ENCODING);
-		v |= add_duplicates(ctx, type, &str, end, ACCEPT_ENCODING);
+		v |= add_header(ctx, type, &str, end_minus_1, ACCEPT_ENCODING);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, ACCEPT_ENCODING);
 
-		v |= add_header(ctx, type, &str, end, COOKIE);
-		v |= add_duplicates(ctx, type, &str, end, COOKIE);
+		v |= add_header(ctx, type, &str, end_minus_1, COOKIE);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, COOKIE);
 
-		v |= add_header(ctx, type, &str, end, X_FORWARDED_FOR);
-		v |= add_duplicates(ctx, type, &str, end, X_FORWARDED_FOR);
+		v |= add_header(ctx, type, &str, end_minus_1, X_FORWARDED_FOR);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, X_FORWARDED_FOR);
 
-		v |= add_header(ctx, type, &str, end, USER_AGENT);
-		v |= add_duplicates(ctx, type, &str, end, USER_AGENT);
+		v |= add_header(ctx, type, &str, end_minus_1, USER_AGENT);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, USER_AGENT);
 	}
 	else if (type == FUZZ_RESP) {
-		v |= add_header(ctx, type, &str, end, ACCEPT_RANGES);
-		v |= add_duplicates(ctx, type, &str, end, ACCEPT_RANGES);
+		v |= add_header(ctx, type, &str, end_minus_1, ACCEPT_RANGES);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, ACCEPT_RANGES);
 
-		v |= add_header(ctx, type, &str, end, SET_COOKIE);
-		v |= add_duplicates(ctx, type, &str, end, SET_COOKIE);
+		v |= add_header(ctx, type, &str, end_minus_1, SET_COOKIE);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, SET_COOKIE);
 
-		v |= add_header(ctx, type, &str, end, ETAG);
-		v |= add_duplicates(ctx, type, &str, end, ETAG);
+		v |= add_header(ctx, type, &str, end_minus_1, ETAG);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, ETAG);
 
-		v |= add_header(ctx, type, &str, end, SERVER);
-		v |= add_duplicates(ctx, type, &str, end, SERVER);
+		v |= add_header(ctx, type, &str, end_minus_1, SERVER);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, SERVER);
 
-		v |= add_header(ctx, type, &str, end, EXPIRES);
-		v |= add_duplicates(ctx, type, &str, end, EXPIRES);
+		v |= add_header(ctx, type, &str, end_minus_1, EXPIRES);
+		v |= add_duplicates(ctx, type, &str, end_minus_1, EXPIRES);
 	}
 
 	n = ctx->i[TRANSFER_ENCODING_NUM];
-	v |= __add_header_rand(ctx, type, &str, end, TRANSFER_ENCODING, n);
-	v |= __add_duplicates(ctx, type, &str, end, TRANSFER_ENCODING, n);
+	v |= __add_header_rand(ctx, type, &str, end_minus_1, TRANSFER_ENCODING, n);
+	v |= __add_duplicates(ctx, type, &str, end_minus_1, TRANSFER_ENCODING, n);
+
+	v |= add_header(ctx, type, &str, end_minus_1, CONNECTION);
+	v |= add_duplicates(ctx, type, &str, end_minus_1, CONNECTION);
+
+	v |= add_header(ctx, type, &str, end_minus_1, CONTENT_TYPE);
+	v |= add_duplicates(ctx, type, &str, end_minus_1, CONTENT_TYPE);
+
+	v |= add_header(ctx, type, &str, end_minus_1, CONTENT_LENGTH);
+	v |= add_duplicates(ctx, type, &str, end_minus_1, CONTENT_LENGTH);
+
+	v |= add_header(ctx, type, &str, end_minus_1, CACHE_CONTROL);
+	v |= add_duplicates(ctx, type, &str, end_minus_1, CACHE_CONTROL);
+
+	add_string(ctx, &str, end_minus_1, "\r\n");
+
+	/*
+	 * That's not too bad to add body to invalid message
+	 * supposed to have empty body.
+	 */
+	if (!(v & FUZZ_MSG_F_EMPTY_BODY) || (v & FUZZ_MSG_F_INVAL))
+		v |= add_body(ctx, &str, end_minus_1, type);
+
+	BUG_ON(str > end);
+	*str = '\0';
+	if (ctx->is_buf_not_enough) {
+		v |= FUZZ_INVALID;
+	}
+
+	if (!(v & FUZZ_INVALID) && !fuzz_hdrs_compatible(ctx, type, v))
+		v |= FUZZ_INVALID;
+
+	for (i = 0; i < move; i++) {
+		ret = gen_vector_move(ctx, start);
+		if (ret == FUZZ_END)
+			break;
+	}
+
+	if (v & FUZZ_INVALID)
+		return FUZZ_INVALID;
+	return ret;
+}
+EXPORT_SYMBOL(fuzz_gen);
 
-	v |= add_header(ctx, type, &str, end, CONNECTION);
-	v |= add_duplicates(ctx, type, &str, end, CONNECTION);
+/**
+ * @returns FUZZ_VALID if the result is a valid HTTP/2 message, FUZZ_INVALID
+ * if the result is an invalid HTTP/2 message, FUZZ_END if the HTTP/2 message
+ * sequence is over.
+ *
+ * @move is how many gen_vector's elements should be changed each time a new
+ * HTTP/2 message is generated, should be >= 1.
+ */
+int
+fuzz_gen_h2(TfwFuzzContext *ctx, char *str, char *end, field_t start,
+	 int move, int type, unsigned int *headers_len, unsigned int *body_len)
+{
+	char *saved_str = str;
+	int i, ret = FUZZ_VALID;
+	unsigned int v = 0;
+
+	BUG_ON(type != FUZZ_REQ_H2);
+
+	ctx->hdr_flags = 0;
+	memset(ctx->fld_flags, 0, sizeof(ctx->fld_flags));
+	ctx->is_buf_not_enough = false;
 
-	v |= add_header(ctx, type, &str, end, CONTENT_TYPE);
+	if (str == NULL)
+		return -EINVAL;
+
+	v |= add_header(ctx, type, &str, end, METHOD);
+	v |= add_header(ctx, type, &str, end, SCHEME);
+	v |= add_header(ctx, type, &str, end, PATH);
+
+	v |= add_header(ctx, type, &str, end, HOST);
+	v |= add_duplicates(ctx, type, &str, end, HOST);
+
+	v |= add_header(ctx, type, &str, end, ACCEPT);
+	v |= add_duplicates(ctx, type, &str, end, ACCEPT);
+
+	v |= add_header(ctx, type, &str, end, ACCEPT_LANGUAGE);
+	v |= add_duplicates(ctx, type, &str, end, ACCEPT_LANGUAGE);
+
+	v |= add_header(ctx, type, &str, end, ACCEPT_ENCODING);
+	v |= add_duplicates(ctx, type, &str, end, ACCEPT_ENCODING);
+
+	v |= add_header(ctx, type, &str, end, COOKIE);
+
+	v |= add_header(ctx, type, &str, end, X_FORWARDED_FOR);
+	v |= add_duplicates(ctx, type, &str, end, X_FORWARDED_FOR);
+
+	v |= add_header(ctx, type, &str, end, USER_AGENT);
+	v |= add_duplicates(ctx, type, &str, end, USER_AGENT);
+
+	v |= add_header_rand(ctx, type, &str, end, CONTENT_TYPE);
 	v |= add_duplicates(ctx, type, &str, end, CONTENT_TYPE);
 
-	v |= add_header(ctx, type, &str, end, CONTENT_LENGTH);
+	v |= add_header_rand(ctx, type, &str, end, CONTENT_LENGTH);
 	v |= add_duplicates(ctx, type, &str, end, CONTENT_LENGTH);
 
 	v |= add_header(ctx, type, &str, end, CACHE_CONTROL);
 	v |= add_duplicates(ctx, type, &str, end, CACHE_CONTROL);
 
-	add_string(&str, end, "\r\n");
+	*headers_len = str - saved_str;
+	saved_str = str;
 
 	/*
 	 * That's not too bad to add body to invalid message
@@ -786,11 +1020,11 @@ fuzz_gen(TfwFuzzContext *ctx, char *str, char *end, field_t start,
 	if (!(v & FUZZ_MSG_F_EMPTY_BODY) || (v & FUZZ_MSG_F_INVAL))
 		v |= add_body(ctx, &str, end, type);
 
-	if (str < end) {
-		*str = '\0';
-	} else {
+	*body_len = str - saved_str;
+
+	BUG_ON(str > end);
+	if (ctx->is_buf_not_enough) {
 		v |= FUZZ_INVALID;
-		*(end - 1) = '\0';
 	}
 
 	if (!(v & FUZZ_INVALID) && !fuzz_hdrs_compatible(ctx, type, v))
@@ -806,4 +1040,4 @@ fuzz_gen(TfwFuzzContext *ctx, char *str, char *end, field_t start,
 		return FUZZ_INVALID;
 	return ret;
 }
-EXPORT_SYMBOL(fuzz_gen);
+EXPORT_SYMBOL(fuzz_gen_h2);
diff --git a/fw/t/fuzzer.h b/fw/t/fuzzer.h
index 1eea2e08a..ae423fe5b 100644
--- a/fw/t/fuzzer.h
+++ b/fw/t/fuzzer.h
@@ -58,15 +58,19 @@ typedef enum {
 	SERVER,
 	CACHE_CONTROL,
 	EXPIRES,
+	SCHEME,		// intended only for HTTP2
+	PATH,		// intended only for HTTP2
 	TRANSFER_ENCODING_NUM,
 	URI_PATH_DEPTH,
 	BODY_CHUNKS_NUM,
-	N_FIELDS,
+	N_FIELDS
 } field_t;
 
 /*
  * @hdr_flags		- a flag for each header;
  * @fld_flags		- message and contents flags;
+ * @is_buf_not_enough   - a flag is true if generated message did not fit
+ *                        into str (buffer) given in fuzz_gen/fuzz_gen_h2
  */
 typedef struct {
 	int i[N_FIELDS];
@@ -75,6 +79,7 @@ typedef struct {
 	int curr_duplicates;
 	unsigned int hdr_flags;
 	unsigned int fld_flags[N_FIELDS];
+	bool is_buf_not_enough;
 } TfwFuzzContext;
 
 void fuzz_init(TfwFuzzContext *context, bool is_only_valid);
@@ -82,4 +87,6 @@ void fuzz_init(TfwFuzzContext *context, bool is_only_valid);
 int fuzz_gen(TfwFuzzContext *context, char *str, char *end, field_t start,
 	     int move, int type);
 
+int fuzz_gen_h2(TfwFuzzContext *context, char *str, char *end, field_t start,
+	     int move, int type, unsigned int *headers_len, unsigned int *body_len);
 #endif /* __TFW_FUZZER_H__ */
diff --git a/fw/t/unit/test_http2_parser.c b/fw/t/unit/test_http2_parser.c
index 8b009688e..fa90de975 100644
--- a/fw/t/unit/test_http2_parser.c
+++ b/fw/t/unit/test_http2_parser.c
@@ -2635,6 +2635,56 @@ do {										\
 #undef H2_BUF
 }
 
+TEST(http2_parser, fuzzer)
+{
+#define N 6	// Count of generations
+#define MOVE 1	// Mutations per generation
+
+	size_t len = 10 * 1024 * 1024;
+	char *str;
+	unsigned int headers_len = 0, body_len = 0;
+	int ret;
+	int field, i;
+	TfwFuzzContext context;
+
+	kernel_fpu_end();
+	str = vmalloc(len);
+	kernel_fpu_begin();
+
+	fuzz_init(&context, false);
+
+	for (field = SPACES; field < N_FIELDS; field++) {
+		for (i = 0; i < N; i++) {
+			TEST_DBG3("start field: %d request: %d\n", field, i);
+			ret = fuzz_gen_h2(&context, str, str + len, field, MOVE,
+				       FUZZ_REQ_H2, &headers_len, &body_len);
+			INIT_FRAMES();
+			ADD_HEADERS_FRAME(str, headers_len);
+			ADD_DATA_FRAME(str + headers_len, body_len);
+			test_case_parse_prepare_h2();
+			switch (ret) {
+			case FUZZ_VALID:
+				TRY_PARSE_EXPECT_PASS(FUZZ_REQ_H2, CHUNK_ON);
+				break;
+			case FUZZ_INVALID:
+				TRY_PARSE_EXPECT_BLOCK(FUZZ_REQ_H2, CHUNK_ON);
+				break;
+			case FUZZ_END:
+			default:
+				goto end;
+			}
+
+			/* Fuzzer generates huge debug message flow. */
+			test_debug_relax();
+		}
+	}
+
+end:
+	kernel_fpu_end();
+	vfree(str);
+	kernel_fpu_begin();
+}
+
 TEST_SUITE(http2_parser)
 {
 	TEST_RUN(http2_parser, http2_check_important_fields);
@@ -2653,13 +2703,13 @@ TEST_SUITE(http2_parser)
 	TEST_RUN(http2_parser, cookie);
 	TEST_RUN(http2_parser, if_none_match);
 	TEST_RUN(http2_parser, referer);
-//	TEST_RUN(http2_parser, fuzzer);		// TODO
 	TEST_RUN(http2_parser, content_type_line_parser);
 	TEST_RUN(http2_parser, xff);
 	TEST_RUN(http2_parser, date);
 	TEST_RUN(http2_parser, method_override);
 	TEST_RUN(http2_parser, vchar);
 	TEST_RUN(http2_parser, perf);
+	TEST_RUN(http2_parser, fuzzer);
 
 	/*
 	 * Testing for correctness of redirection mark parsing (in
diff --git a/fw/t/unit/test_http_parser_common.h b/fw/t/unit/test_http_parser_common.h
index 0d1e744de..03e35dcba 100644
--- a/fw/t/unit/test_http_parser_common.h
+++ b/fw/t/unit/test_http_parser_common.h
@@ -294,6 +294,30 @@ do {										\
 	frames_total_sz = 0;							\
 	bzero_fast(frames, sizeof(frames))
 
+#define ADD_HEADERS_FRAME(frame, frame_sz)					\
+do {										\
+	BUG_ON(frames_cnt >= ARRAY_SIZE(frames));				\
+	bzero_fast(&frames[frames_cnt], sizeof(frames[0]));			\
+	frames[frames_cnt].subtype = HTTP2_HEADERS;				\
+	frames[frames_cnt].str = frame;						\
+	frames[frames_cnt].len = frame_sz;					\
+	frames_max_sz = max(frames_max_sz, frame_sz);				\
+	frames_total_sz += frame_sz;						\
+	++frames_cnt;								\
+} while(0)
+
+#define ADD_DATA_FRAME(frame, frame_sz)						\
+do {										\
+	BUG_ON(frames_cnt >= ARRAY_SIZE(frames));				\
+	bzero_fast(&frames[frames_cnt], sizeof(frames[0]));			\
+	frames[frames_cnt].subtype = HTTP2_DATA;				\
+	frames[frames_cnt].str = frame;						\
+	frames[frames_cnt].len = frame_sz;					\
+	frames_max_sz = max(frames_max_sz, frame_sz);				\
+	frames_total_sz += frame_sz;						\
+	++frames_cnt;								\
+} while(0)
+
 #define GET_FRAMES_MAX_SZ() \
 	({frames_max_sz;})
 
@@ -444,6 +468,7 @@ do_split_and_parse(int type, int chunk_mode)
 
 		req = test_req_alloc(GET_FRAMES_TOTAL_SZ());
 		conn.h2.hpack.state = 0;
+		conn.h2.hpack.length = 0;
 		req->conn = (TfwConn*)&conn;
 		req->pit.parsed_hdr = &stream.parser.hdr;
 		req->stream = &stream;
